"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _plugin() {
  const data = require("@parcel/plugin");
  _plugin = function () {
    return data;
  };
  return data;
}
function _sourceMap() {
  const data = _interopRequireDefault(require("@parcel/source-map"));
  _sourceMap = function () {
    return data;
  };
  return data;
}
function _coffeescript() {
  const data = _interopRequireDefault(require("coffeescript"));
  _coffeescript = function () {
    return data;
  };
  return data;
}
function _utils() {
  const data = require("@parcel/utils");
  _utils = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var _default = exports.default = new (_plugin().Transformer)({
  async transform({
    asset,
    options
  }) {
    let sourceFileName = (0, _utils().relativeUrl)(options.projectRoot, asset.filePath);
    asset.type = 'js';
    let output = _coffeescript().default.compile(await asset.getCode(), {
      filename: sourceFileName,
      sourceMap: !!asset.env.sourceMap
    });

    // return from compile is based on sourceMap option
    if (asset.env.sourceMap) {
      let map = null;
      if (output.v3SourceMap) {
        map = new (_sourceMap().default)(options.projectRoot);
        map.addVLQMap(JSON.parse(output.v3SourceMap));
      }
      asset.setCode(output.js);
      asset.setMap(map);
    } else {
      asset.setCode(output);
    }
    return [asset];
  }
});